package com.ims.eval.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ims.common.utils.StringUtils;
import com.ims.eval.dao.EvaluationDeptBusinessContentMapper;
import com.ims.eval.entity.DataDictionary;
import com.ims.eval.entity.EvaluationDeptBusinessContent;
import com.ims.eval.service.IDataDictionaryService;
import com.ims.eval.service.IEvaluationDeptBusinessContentService;
import com.ims.eval.service.IUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * @author hlf
 * @date 2023/5/6 10:40
 * 文件说明：
 */
@Service
public class EvaluationDeptBusinessContentServiceImpl extends ServiceImpl<EvaluationDeptBusinessContentMapper, EvaluationDeptBusinessContent> implements IEvaluationDeptBusinessContentService {

	@Autowired
	private IUserService userService;

	@Autowired
	private IDataDictionaryService dataDictionaryService;

	@Override
	public List<EvaluationDeptBusinessContent> detailsList(String businessPlanId, HttpServletRequest request) {
		List<EvaluationDeptBusinessContent> evaluationDeptBusinessContentList = baseMapper.detailsList(businessPlanId);
		/*Myuser myuser = userService.getSysUser(request);
		if (null != myuser) {
			throw new CustomException("暂无权限");
		} else {
			for (EvaluationDeptBusinessContent evaluationDeptBusinessContent : evaluationDeptBusinessContentList) {
				boolean updateMark = false;
				if (!"".equals(myuser.getDeptId())) {
					if (myuser.getDeptId().equals(evaluationDeptBusinessContent.getDeptId())) {
						updateMark = true;
					} else if (myuser.getLoginName().equals("admin")) {
						updateMark = true;
					} else {
						throw new CustomException("暂无权限");
					}
				}
				evaluationDeptBusinessContent.setUpdateMark(updateMark);
			}
		}
		return null;*/
		evaluationDeptBusinessContentList.stream().forEach(i -> {
			i.setUpdateMark(true);
		});
		return evaluationDeptBusinessContentList;
	}

	@Override
	public boolean removeByBusinessPlanId(String businessPlanId) {
		return baseMapper.removeByBusinessPlanId(businessPlanId);
	}

	@Override
	public boolean saveOrUpdateBatch(List<EvaluationDeptBusinessContent> evaluationDeptBusinessContentList) {
		boolean b = false;
		for (EvaluationDeptBusinessContent evaluationDeptBusinessContent : evaluationDeptBusinessContentList) {
			if (StringUtils.isEmpty(evaluationDeptBusinessContent.getId())) {
				DataDictionary dataDictionary = dataDictionaryService.getById(evaluationDeptBusinessContent.getDeptId());
				evaluationDeptBusinessContent.setDeptName(dataDictionary.getKeyName());
				evaluationDeptBusinessContent.setDeptCode(dataDictionary.getDataKey());
				b = super.save(evaluationDeptBusinessContent);
			} else {
				b = super.updateById(evaluationDeptBusinessContent);
			}
		}
		return b;
	}
}
